using System;
using System.Runtime.InteropServices;

/// <summary>
/// AWG-10K API library definitions
/// </summary>
public class AWG10K
{
	//
	// Return code
	//
    public const int AWG10K_OK = 0;
    public const int AWG10K_INVALID_ID = 1;
    public const int AWG10K_DEVICE_NOT_FOUND = 2;
    public const int AWG10K_DEVICE_NOT_OPENED = 3;
    public const int AWG10K_INVALID_PARAMETER = 4;
    public const int AWG10K_MEMORY_ERROR = 5;
    public const int AWG10K_COMMUNICATION_ERROR = 6;
    public const int AWG10K_EXECUTION_ERROR = 7;
    public const int AWG10K_OTHER_ERROR = 8;

    //
    // Constants (AWG-10K status)
    //
	public const byte AWG10K_STATUS_NO_DATA = 0;	// g`o͒~(g`t@Cݒ)
    public const byte AWG10K_STATUS_READY = 1;	    // g`o͒~(g`t@Cݒ)
    public const byte AWG10K_STATUS_RUNNING = 2;	// g`o͒

    //
	// Functions definitions
	//
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_GetNumberOfDevices (out int Number);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_GetSerialNumber (int Index, out int SerialNumber);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_Open (out byte ID);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_OpenBySerialNumber (int SerialNumber, out byte ID);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_Close(byte ID);

    [DllImport("AWG10K.dll", CharSet = CharSet.Ansi)]
    public static extern int AWG10K_SetFile (byte ID, string FilePath);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_Start (byte ID);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_Stop (byte ID);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_GetStatus (byte ID, out byte Status);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_OutputPort (byte ID, byte Port);
    [DllImport("AWG10K.dll")]
    public static extern int AWG10K_InputPort (byte ID, out byte Port);
}
