Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

'---------------------------------
' AWG-10K API library definitions
'---------------------------------

Module AWG10K

    '
    ' Return code
    '
    Public Const AWG10K_OK As Integer = 0
    Public Const AWG10K_INVALID_ID As Integer = 1
    Public Const AWG10K_DEVICE_NOT_FOUND As Integer = 2
    Public Const AWG10K_DEVICE_NOT_OPENED As Integer = 3
    Public Const AWG10K_INVALID_PARAMETER As Integer = 4
    Public Const AWG10K_MEMORY_ERROR As Integer = 5
    Public Const AWG10K_COMMUNICATION_ERROR As Integer = 6
    Public Const AWG10K_EXECUTION_ERROR As Integer = 7
    Public Const AWG10K_OTHER_ERROR As Integer = 8

    '
    ' Constants (AWG-10K status)
    '
    Public Const AWG10K_STATUS_NO_DATA As Byte = 0   ' g`o͒~(g`t@Cݒ)
    Public Const AWG10K_STATUS_READY As Byte = 1     ' g`o͒~(g`t@Cݒ)
    Public Const AWG10K_STATUS_RUNNING As Byte = 2   ' g`o͒

    '
    ' Functions definitions
    '
    Public Declare Function AWG10K_GetNumberOfDevices Lib "AWG10K.dll" (ByRef Number As Integer) As Integer
    Public Declare Function AWG10K_GetSerialNumber Lib "AWG10K.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function AWG10K_Open Lib "AWG10K.dll" (ByRef ID As Byte) As Integer
    Public Declare Function AWG10K_OpenBySerialNumber Lib "AWG10K.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function AWG10K_Close Lib "AWG10K.dll" (ByVal ID As Byte) As Integer

    Public Declare Ansi Function AWG10K_SetFile Lib "AWG10K.dll" (ByVal ID As Byte, ByVal FilePath As String) As Integer
    Public Declare Function AWG10K_Start Lib "AWG10K.dll" (ByVal ID As Byte) As Integer
    Public Declare Function AWG10K_Stop Lib "AWG10K.dll" (ByVal ID As Byte) As Integer
    Public Declare Function AWG10K_GetStatus Lib "AWG10K.dll" (ByVal ID As Byte, ByRef Status As Byte) As Integer
    Public Declare Function AWG10K_OutputPort Lib "AWG10K.dll" (ByVal ID As Byte, ByVal Port As Byte) As Integer
    Public Declare Function AWG10K_InputPort Lib "AWG10K.dll" (ByVal ID As Byte, ByRef Port As Byte) As Integer

End Module
