/*++

Copyright (c) 2014 ELMOS Co., Ltd.

Module Name:
	AWG10K.h
Abstract:
	AWG-10K API library definitions
Revision History:
	14/09/18	Created.

--*/

#ifndef AWG10K_H
#define AWG10K_H

#ifdef AWG10K_EXPORTS_
#define AWG10K_API __declspec(dllexport)
#else
#define AWG10K_API __declspec(dllimport)
#endif

//
// Return code
//
enum {
	AWG10K_OK,
   	AWG10K_INVALID_ID,
    AWG10K_DEVICE_NOT_FOUND,
    AWG10K_DEVICE_NOT_OPENED,
	AWG10K_INVALID_PARAMETER,
	AWG10K_MEMORY_ERROR,
	AWG10K_COMMUNICATION_ERROR,
	AWG10K_EXECUTION_ERROR,
	AWG10K_OTHER_ERROR
};

//
// Constants
//
#define	AWG10K_STATUS_NO_DATA	0	// g`o͒~(g`t@Cݒ)
#define	AWG10K_STATUS_READY		1	// g`o͒~(g`t@Cݒ)
#define	AWG10K_STATUS_RUNNING	2	// g`o͒

#ifdef __cplusplus
extern "C" {
#endif

//
// Function definitions
//
AWG10K_API int WINAPI AWG10K_GetNumberOfDevices (int *Number);
AWG10K_API int WINAPI AWG10K_GetSerialNumber (int Index, int *SerialNumber);
AWG10K_API int WINAPI AWG10K_Open (BYTE *ID);
AWG10K_API int WINAPI AWG10K_OpenBySerialNumber (int SerialNumber, BYTE *ID);
AWG10K_API int WINAPI AWG10K_Close (BYTE ID);
AWG10K_API int WINAPI AWG10K_SetFile (BYTE ID, const char *FilePath);
AWG10K_API int WINAPI AWG10K_Start (BYTE ID);
AWG10K_API int WINAPI AWG10K_Stop (BYTE ID);
AWG10K_API int WINAPI AWG10K_GetStatus (BYTE ID, BYTE *Status);
AWG10K_API int WINAPI AWG10K_OutputPort (BYTE ID, BYTE Port);
AWG10K_API int WINAPI AWG10K_InputPort (BYTE ID, BYTE *Port);

#ifdef __cplusplus
}
#endif

#endif  /* AWG10K_H */
